
/////////////////////////////////Voltmeter_Display//////////////////////////////
//////////////////////measuring range 0------50v////////////////////////////////

//////////////////////////Declare variables/////////////////////////////////////
unsigned char display[10] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x67};
unsigned char display1[10]= {0xBF,0x86,0xDB,0xCF,0xE6,0xED,0xFD,0x87,0xFF,0xE7};
unsigned int adc_rd;
long tlong;
//////////////////////////////////////////////////////// ///////////////////////

void set_up() {   //configuration for Pic16f887

  ANSEL = 0x04;      // Pin RA2 sets as analog input.
  TRISA = 0x04;
  ADCON1 = 0x82;    // the Vref is Vcc.
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  TRISB = 0;
  TRISD = 0;    // Clear  PORTB and PORTD.
  PORTB = 0;
  PORTD = 0;

}
void  printf() {

    unsigned char ch1, ch2, ch3, ch4;
    short int i=0;

    for (i=0; i<=86; i++) { // routine to stabilize the changes of voltage
    ch1 = tlong / 1000;
    PORTD = 1;              // on  ones  ch4,  off  ch1, ch2 and ch4.
    PORTB = display[ch1] ;
    delay_ms(2);
    ch2 = (tlong/100) % 10 ;
    PORTD = 2;             // on  thousands and ch1, off ch2, ch3 and ch4.
    PORTB = display1[ch2] ;
    delay_ms(2);
    ch3 = (tlong/10) % 10;
    PORTD = 4;             // on hundreds and ch2, off  ch1, ch3 and ch4.
    PORTB = display[ch3] ;
    delay_ms(2);
    ch4 = tlong % 10;
    PORTD = 8;            // o n tens and ch3, off ch1, ch2 and ch4.
    PORTB = display[ch4] ;
    delay_ms(2);
  }
}
void Greeting() {

    short int i=0;
    for(i=0; i<=100; i++){  //routine to see message
    PORTD = 1;
    PORTB = 0x76 ;  //H
    delay_ms(2);
    PORTD = 2;
    PORTB = 0x79 ;  //E
    delay_ms(2);
    PORTD = 4;
    PORTB = 0x36;   //ll
    delay_ms(2);
    PORTD = 8;
    PORTB = 0x3F;   //0
    delay_ms(2);
 }
 PORTD = 0;    // clear PORTB and PORTD.
 PORTB = 0;
}
 void main() {
   set_up();
   Greeting();
   while (1) {
    adc_rd = ADC_Read(2);  // A/D conversion. Pin RA2 is an input.
    delay_ms(1);
    tlong = (long)adc_rd * 5000;  // Convert the result in millivolts.
    tlong = tlong / 1023;   // 0..1023
    printf();
  }
} //END.
//////////////////////////////////////////////////////// ///////////////////////
//NOTE: this circuit uses the 7-segment displays of common cathode but if you
// want to use displays of common anode you could change them to these values.
//display[10] ={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x98};
//display1[10] ={0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0x00,0x18};
//////////////////////////////////////////////////////// ///////////////////////